﻿Public Class Form1
    Structure OutAnalogInforStru
        Dim DeviceNo As Byte  '0, 1, 2, 3 are deviceNo value
        Dim WhichType As Byte  '0 ----Analog, 1----Din, 2----Fault In, 3-----WarnIn, it should be 0
        Dim AnalogNo As Byte   '0 to 31
        Dim Analog As Single  '32 analog,  Physical Value        
        Dim checksum As UShort
    End Structure
    Structure OutDinInforStru
        Dim DeviceNo As Byte  '0, 1, 2, 3 are deviceNo value
        Dim WhichType As Byte  '0 ----Analog, 1----Din, 2----Fault In, 3-----WarnIn, it should be 1       
        Dim Din As UShort '10 din        
        Dim checksum As UShort
    End Structure
    Structure OutFaultInforStru
        Dim DeviceNo As Byte  '0, 1, 2, 3 are deviceNo value
        Dim WhichType As Byte  '0 ----Analog, 1----Din, 2----Fault In, 3-----WarnIn, it should be 2            
        Dim FaultIn As UInteger '32 fault inputs
        Dim checksum As UShort
    End Structure
    Structure OutWarnInforStru
        Dim DeviceNo As Byte  '0, 1, 2, 3 are deviceNo value
        Dim WhichType As Byte  '0 ----Analog, 1----Din, 2----Fault In, 3-----WarnIn,it should be 3                  
        Dim WarnIn As UInteger '32 fault inputs
        Dim checksum As UShort
    End Structure
    Structure OutCMDStru
        Dim DeviceNo As Byte  '0xFF are deviceNo value--Command        
        Dim Command As UShort   'Command : First byte 0x0-None, 0xF0--connect, 0x0F--Disconnect
        ' The 2nd byte:  No meaning
        Dim checksum As UShort
    End Structure
    Structure InDataInforStru
        Dim DeviceNo As Byte  '0, 1, 2, 3 are deviceNo value
        Dim FaultIn As UInteger '32 fault inputs
        Dim WarnIn As UInteger '32 fault inputs
        Dim checksum As UShort
    End Structure
    Structure InDebugInforStru
        Dim DeviceNo As Byte  '0xFF are Debug infor Flag
        <VBFixedArray(31)> Dim Debug() As UShort  '32 double bytes of Debug
        <VBFixedArray(31)> Dim DebugSng() As Single  '32 four bytes of DebugSng
        Dim checksum As UShort
    End Structure
    Dim AnalogToSimulator As OutAnalogInforStru
    Dim DinToSimulator As OutDinInforStru
    Dim FaultToSimulator As OutFaultInforStru
    Dim WarnToSimulator As OutWarnInforStru
    Dim CMDToSimulator As OutCMDStru
    Dim DataFrmSimulator As InDataInforStru
    Dim DataFrmSimulator_old As InDataInforStru
    Dim DebugFrmSimulator As InDebugInforStru
    Dim DebugFrmSimulator_old As InDebugInforStru
    Dim SyncLockReceved As String = ""

    Private MySimulatorInstance As New Process()
    Private Sub Form1_FormClosing(sender As Object, e As FormClosingEventArgs) Handles Me.FormClosing
        Try
            VrSerialPort1.Close()
        Catch ex As Exception
            MsgBox(ex.Message)
        End Try
        Try
            MySimulatorInstance.Kill()
        Catch ex As Exception
            MsgBox(ex.Message)
        End Try


    End Sub

    Private Sub Form1_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        cmbWhichDevice.SelectedIndex = 0
        VrSerialPort1.PortName = "VCOM2"
        Try
            VrSerialPort1.Open()
        Catch ex As Exception
            MsgBox(ex.Message)
            Application.Exit()
        End Try

        Environment.CurrentDirectory = "D:\Project\CANBus_Simulator\pc_software\PC_CAN_Simulator\PC_CAN_Simulator\bin\Debug"
        'MySimulatorInstance.StartInfo = New ProcessStartInfo("D:\Project\CANBus_Simulator\pc_software\PC_CAN_Simulator\PC_CAN_Simulator\bin\Debug\CANSimulator.exe", "VCOM2 ""C:\Users\Jack Xia Laptop\Desktop\test_can\test2"" ""C:\Users\Jack Xia Laptop\Desktop\test_can\test7"" ")
        MySimulatorInstance.StartInfo = New ProcessStartInfo("CANSimulator.exe", "VCOM2 ""C:\Users\Jack Xia Laptop\Desktop\test_can\test2"" ""C:\Users\Jack Xia Laptop\Desktop\test_can\test7"" ")
        MySimulatorInstance.Start()

        DataFrmSimulator.DeviceNo = 0
        DataFrmSimulator.FaultIn = 0
        DataFrmSimulator.WarnIn = 0
        DataFrmSimulator_old.DeviceNo = 0
        DataFrmSimulator_old.FaultIn = 0
        DataFrmSimulator_old.WarnIn = 0

        DebugFrmSimulator.Debug = New UShort(31) {}
        DebugFrmSimulator_old.Debug = New UShort(31) {}
        DebugFrmSimulator.DebugSng = New Single(31) {}
        DebugFrmSimulator_old.DebugSng = New Single(31) {}


    End Sub


    Private Sub btnStart_Click(sender As Object, e As EventArgs) Handles btnStart.Click
        CMDToSimulator.DeviceNo = &HFF  'Device Number =0xff is for command
        CMDToSimulator.Command = &HF0  'connect command
        CMDToSimulator.checksum = CMDToSimulator.DeviceNo + CMDToSimulator.Command
        Dim TransmitByte(4) As Byte
        TransmitByte(0) = CMDToSimulator.DeviceNo
        TransmitByte(1) = CMDToSimulator.Command And &HFF
        TransmitByte(2) = (CMDToSimulator.Command >> 8) And &HFF
        TransmitByte(3) = CMDToSimulator.checksum And &HFF
        TransmitByte(4) = (CMDToSimulator.checksum >> 8) And &HFF
        Try
            VrSerialPort1.Write(TransmitByte, 0, 5)
        Catch ex As Exception
            MsgBox(ex.Message)
        End Try
    End Sub

    Private Sub btnStop_Click(sender As Object, e As EventArgs) Handles btnStop.Click
        CMDToSimulator.DeviceNo = &HFF  'Device Number =0xff is for command
        CMDToSimulator.Command = &HF  'Disconnect command
        CMDToSimulator.checksum = CMDToSimulator.DeviceNo + CMDToSimulator.Command
        Dim TransmitByte(4) As Byte
        TransmitByte(0) = CMDToSimulator.DeviceNo
        TransmitByte(1) = CMDToSimulator.Command And &HFF
        TransmitByte(2) = (CMDToSimulator.Command >> 8) And &HFF
        TransmitByte(3) = CMDToSimulator.checksum And &HFF
        TransmitByte(4) = (CMDToSimulator.checksum >> 8) And &HFF
        Try
            VrSerialPort1.Write(TransmitByte, 0, 5)
        Catch ex As Exception
            MsgBox(ex.Message)
        End Try
    End Sub
    Private Sub TransmitSimulaterAnalogValue(ByVal DeviceNo As Byte, ByVal AnalogNumber As Byte, ByVal AnalogValue As Single)
        AnalogToSimulator.DeviceNo = DeviceNo
        AnalogToSimulator.WhichType = 0
        AnalogToSimulator.AnalogNo = AnalogNumber
        'Analog input
        AnalogToSimulator.Analog = AnalogValue


        'Prepare Transmit Data Bytes
        Dim CheckSum As UInteger
        Dim TransmitByte(8) As Byte
        Dim Byte4Single(3) As Byte
        TransmitByte(0) = AnalogToSimulator.DeviceNo
        CheckSum = TransmitByte(0)

        TransmitByte(1) = AnalogToSimulator.WhichType
        CheckSum = CheckSum + TransmitByte(1)

        TransmitByte(2) = AnalogToSimulator.AnalogNo
        CheckSum = CheckSum + TransmitByte(2)

        Byte4Single = BitConverter.GetBytes(AnalogToSimulator.Analog)
        TransmitByte(3) = Byte4Single(0)
        TransmitByte(4) = Byte4Single(1)
        TransmitByte(5) = Byte4Single(2)
        TransmitByte(6) = Byte4Single(3)
        CheckSum = CheckSum + TransmitByte(3)
        CheckSum = CheckSum + TransmitByte(4)
        CheckSum = CheckSum + TransmitByte(5)
        CheckSum = CheckSum + TransmitByte(6)

        TransmitByte(7) = CheckSum And &HFF
        TransmitByte(8) = (CheckSum >> 8) And &HFF

        If VrSerialPort1.IsOpen Then
            Try
                VrSerialPort1.Write(TransmitByte, 0, 9)
            Catch ex As Exception
                MsgBox(ex.Message)
            End Try
        Else
            MsgBox("Please open virtual Serial Port firstly")
        End If
    End Sub
    
    Private Sub TransmitSimulaterDinValue(ByVal DeviceNo As Byte)
        DinToSimulator.DeviceNo = DeviceNo
        DinToSimulator.WhichType = 1
        DinToSimulator.Din = IIf(chkDin1.Checked, 1, 0)
        DinToSimulator.Din = DinToSimulator.Din + IIf(chkDin2.Checked, 2, 0)
        DinToSimulator.Din = DinToSimulator.Din + IIf(chkDin3.Checked, 4, 0)
        DinToSimulator.Din = DinToSimulator.Din + IIf(chkDin4.Checked, 8, 0)
        DinToSimulator.Din = DinToSimulator.Din + IIf(chkDin5.Checked, &H10, 0)
        DinToSimulator.Din = DinToSimulator.Din + IIf(chkDin6.Checked, &H20, 0)
        DinToSimulator.Din = DinToSimulator.Din + IIf(chkDin7.Checked, &H40, 0)
        DinToSimulator.Din = DinToSimulator.Din + IIf(chkDin8.Checked, &H80, 0)
        DinToSimulator.Din = DinToSimulator.Din + IIf(chkDin9.Checked, &H100, 0)
        DinToSimulator.Din = DinToSimulator.Din + IIf(chkDin10.Checked, &H200, 0)

        Dim CheckSum As UInteger
        Dim TransmitByte(5) As Byte
        TransmitByte(0) = DinToSimulator.DeviceNo
        CheckSum = TransmitByte(0)

        TransmitByte(1) = DinToSimulator.WhichType
        CheckSum = CheckSum + TransmitByte(1)

        TransmitByte(2) = DinToSimulator.Din And &HFF
        CheckSum = CheckSum + TransmitByte(2)

        TransmitByte(3) = (DinToSimulator.Din >> 8) And &HFF
        CheckSum = CheckSum + TransmitByte(3)

        TransmitByte(4) = CheckSum And &HFF
        TransmitByte(5) = (CheckSum >> 8) And &HFF

        If VrSerialPort1.IsOpen Then
            Try
                VrSerialPort1.Write(TransmitByte, 0, 6)
            Catch ex As Exception
                MsgBox(ex.Message)
            End Try
        Else
            MsgBox("Please open virtual Serial Port firstly")
        End If

    End Sub

    Private Sub TransmitSimulaterFaultValue(ByVal DeviceNo As Byte)
        FaultToSimulator.DeviceNo = DeviceNo
        FaultToSimulator.WhichType = 2
        FaultToSimulator.FaultIn = IIf(chkFLT1.Checked, 1, 0)
        FaultToSimulator.FaultIn = FaultToSimulator.FaultIn + IIf(chkFLT2.Checked, 2, 0)
        FaultToSimulator.FaultIn = FaultToSimulator.FaultIn + IIf(chkFLT3.Checked, 4, 0)
        FaultToSimulator.FaultIn = FaultToSimulator.FaultIn + IIf(chkFLT4.Checked, 8, 0)

        FaultToSimulator.FaultIn = FaultToSimulator.FaultIn + IIf(chkFLT5.Checked, &H10, 0)
        FaultToSimulator.FaultIn = FaultToSimulator.FaultIn + IIf(chkFLT6.Checked, &H20, 0)
        FaultToSimulator.FaultIn = FaultToSimulator.FaultIn + IIf(chkFLT7.Checked, &H40, 0)
        FaultToSimulator.FaultIn = FaultToSimulator.FaultIn + IIf(chkFLT8.Checked, &H80, 0)

        FaultToSimulator.FaultIn = FaultToSimulator.FaultIn + IIf(chkFLT9.Checked, &H100, 0)
        FaultToSimulator.FaultIn = FaultToSimulator.FaultIn + IIf(chkFLT10.Checked, &H200, 0)
        FaultToSimulator.FaultIn = FaultToSimulator.FaultIn + IIf(chkFLT11.Checked, &H400, 0)
        FaultToSimulator.FaultIn = FaultToSimulator.FaultIn + IIf(chkFLT12.Checked, &H800, 0)

        FaultToSimulator.FaultIn = FaultToSimulator.FaultIn + IIf(chkFLT13.Checked, &H1000, 0)
        FaultToSimulator.FaultIn = FaultToSimulator.FaultIn + IIf(chkFLT14.Checked, &H2000, 0)
        FaultToSimulator.FaultIn = FaultToSimulator.FaultIn + IIf(chkFLT15.Checked, &H4000, 0)
        FaultToSimulator.FaultIn = FaultToSimulator.FaultIn + IIf(chkFLT16.Checked, &H8000, 0)

        FaultToSimulator.FaultIn = FaultToSimulator.FaultIn + IIf(chkFLT17.Checked, &H10000, 0)
        FaultToSimulator.FaultIn = FaultToSimulator.FaultIn + IIf(chkFLT18.Checked, &H20000, 0)
        FaultToSimulator.FaultIn = FaultToSimulator.FaultIn + IIf(chkFLT19.Checked, &H40000, 0)
        FaultToSimulator.FaultIn = FaultToSimulator.FaultIn + IIf(chkFLT20.Checked, &H80000, 0)

        FaultToSimulator.FaultIn = FaultToSimulator.FaultIn + IIf(chkFLT21.Checked, &H100000, 0)
        FaultToSimulator.FaultIn = FaultToSimulator.FaultIn + IIf(chkFLT22.Checked, &H200000, 0)
        FaultToSimulator.FaultIn = FaultToSimulator.FaultIn + IIf(chkFLT23.Checked, &H400000, 0)
        FaultToSimulator.FaultIn = FaultToSimulator.FaultIn + IIf(chkFLT24.Checked, &H800000, 0)

        FaultToSimulator.FaultIn = FaultToSimulator.FaultIn + IIf(chkFLT25.Checked, &H1000000, 0)
        FaultToSimulator.FaultIn = FaultToSimulator.FaultIn + IIf(chkFLT26.Checked, &H2000000, 0)
        FaultToSimulator.FaultIn = FaultToSimulator.FaultIn + IIf(chkFLT27.Checked, &H4000000, 0)
        FaultToSimulator.FaultIn = FaultToSimulator.FaultIn + IIf(chkFLT28.Checked, &H8000000, 0)

        FaultToSimulator.FaultIn = FaultToSimulator.FaultIn + IIf(chkFLT29.Checked, &H10000000, 0)
        FaultToSimulator.FaultIn = FaultToSimulator.FaultIn + IIf(chkFLT30.Checked, &H20000000, 0)
        FaultToSimulator.FaultIn = FaultToSimulator.FaultIn + IIf(chkFLT31.Checked, &H40000000, 0)
        FaultToSimulator.FaultIn = FaultToSimulator.FaultIn + IIf(chkFLT32.Checked, &H80000000UI, 0)

        Dim CheckSum As UInteger
        Dim TransmitByte(7) As Byte
        TransmitByte(0) = FaultToSimulator.DeviceNo
        CheckSum = TransmitByte(0)

        TransmitByte(1) = FaultToSimulator.WhichType
        CheckSum = CheckSum + TransmitByte(1)

        TransmitByte(2) = FaultToSimulator.FaultIn And &HFF
        CheckSum = CheckSum + TransmitByte(2)
        TransmitByte(3) = (FaultToSimulator.FaultIn >> 8) And &HFF
        CheckSum = CheckSum + TransmitByte(3)
        TransmitByte(4) = (FaultToSimulator.FaultIn >> 16) And &HFF
        CheckSum = CheckSum + TransmitByte(4)
        TransmitByte(5) = (FaultToSimulator.FaultIn >> 24) And &HFF
        CheckSum = CheckSum + TransmitByte(5)

        TransmitByte(6) = CheckSum And &HFF
        TransmitByte(7) = (CheckSum >> 8) And &HFF

        If VrSerialPort1.IsOpen Then
            Try
                VrSerialPort1.Write(TransmitByte, 0, 8)
            Catch ex As Exception
                MsgBox(ex.Message)
            End Try
        Else
            MsgBox("Please open virtual Serial Port firstly")
        End If
    End Sub

    Private Sub TransmitSimulaterWarningValue(ByVal DeviceNo As Byte)
        WarnToSimulator.DeviceNo = DeviceNo
        WarnToSimulator.WhichType = 3
        WarnToSimulator.WarnIn = IIf(chkWrn1.Checked, 1, 0)
        WarnToSimulator.WarnIn = WarnToSimulator.WarnIn + IIf(chkWrn2.Checked, 2, 0)
        WarnToSimulator.WarnIn = WarnToSimulator.WarnIn + IIf(chkWrn3.Checked, 4, 0)
        WarnToSimulator.WarnIn = WarnToSimulator.WarnIn + IIf(chkWrn4.Checked, 8, 0)

        WarnToSimulator.WarnIn = WarnToSimulator.WarnIn + IIf(chkWrn5.Checked, &H10, 0)
        WarnToSimulator.WarnIn = WarnToSimulator.WarnIn + IIf(chkWrn6.Checked, &H20, 0)
        WarnToSimulator.WarnIn = WarnToSimulator.WarnIn + IIf(chkWrn7.Checked, &H40, 0)
        WarnToSimulator.WarnIn = WarnToSimulator.WarnIn + IIf(chkWrn8.Checked, &H80, 0)

        WarnToSimulator.WarnIn = WarnToSimulator.WarnIn + IIf(chkWrn9.Checked, &H100, 0)
        WarnToSimulator.WarnIn = WarnToSimulator.WarnIn + IIf(chkWrn10.Checked, &H200, 0)
        WarnToSimulator.WarnIn = WarnToSimulator.WarnIn + IIf(chkWrn11.Checked, &H400, 0)
        WarnToSimulator.WarnIn = WarnToSimulator.WarnIn + IIf(chkWrn12.Checked, &H800, 0)

        WarnToSimulator.WarnIn = WarnToSimulator.WarnIn + IIf(chkWrn13.Checked, &H1000, 0)
        WarnToSimulator.WarnIn = WarnToSimulator.WarnIn + IIf(chkWrn14.Checked, &H2000, 0)
        WarnToSimulator.WarnIn = WarnToSimulator.WarnIn + IIf(chkWrn15.Checked, &H4000, 0)
        WarnToSimulator.WarnIn = WarnToSimulator.WarnIn + IIf(chkWrn16.Checked, &H8000, 0)

        WarnToSimulator.WarnIn = WarnToSimulator.WarnIn + IIf(chkWrn17.Checked, &H10000, 0)
        WarnToSimulator.WarnIn = WarnToSimulator.WarnIn + IIf(chkWrn18.Checked, &H20000, 0)
        WarnToSimulator.WarnIn = WarnToSimulator.WarnIn + IIf(chkWrn19.Checked, &H40000, 0)
        WarnToSimulator.WarnIn = WarnToSimulator.WarnIn + IIf(chkWrn20.Checked, &H80000, 0)

        WarnToSimulator.WarnIn = WarnToSimulator.WarnIn + IIf(chkWrn21.Checked, &H100000, 0)
        WarnToSimulator.WarnIn = WarnToSimulator.WarnIn + IIf(chkWrn22.Checked, &H200000, 0)
        WarnToSimulator.WarnIn = WarnToSimulator.WarnIn + IIf(chkWrn23.Checked, &H400000, 0)
        WarnToSimulator.WarnIn = WarnToSimulator.WarnIn + IIf(chkWrn24.Checked, &H800000, 0)

        WarnToSimulator.WarnIn = WarnToSimulator.WarnIn + IIf(chkWrn25.Checked, &H1000000, 0)
        WarnToSimulator.WarnIn = WarnToSimulator.WarnIn + IIf(chkWrn26.Checked, &H2000000, 0)
        WarnToSimulator.WarnIn = WarnToSimulator.WarnIn + IIf(chkWrn27.Checked, &H4000000, 0)
        WarnToSimulator.WarnIn = WarnToSimulator.WarnIn + IIf(chkWrn28.Checked, &H8000000, 0)

        WarnToSimulator.WarnIn = WarnToSimulator.WarnIn + IIf(chkWrn29.Checked, &H10000000, 0)
        WarnToSimulator.WarnIn = WarnToSimulator.WarnIn + IIf(chkWrn30.Checked, &H20000000, 0)
        WarnToSimulator.WarnIn = WarnToSimulator.WarnIn + IIf(chkWrn31.Checked, &H40000000, 0)
        WarnToSimulator.WarnIn = WarnToSimulator.WarnIn + IIf(chkWrn32.Checked, &H80000000UI, 0)

        Dim CheckSum As UInteger
        Dim TransmitByte(7) As Byte
        TransmitByte(0) = WarnToSimulator.DeviceNo
        CheckSum = TransmitByte(0)

        TransmitByte(1) = WarnToSimulator.WhichType
        CheckSum = CheckSum + TransmitByte(1)

        TransmitByte(2) = WarnToSimulator.WarnIn And &HFF
        CheckSum = CheckSum + TransmitByte(2)
        TransmitByte(3) = (WarnToSimulator.WarnIn >> 8) And &HFF
        CheckSum = CheckSum + TransmitByte(3)
        TransmitByte(4) = (WarnToSimulator.WarnIn >> 16) And &HFF
        CheckSum = CheckSum + TransmitByte(4)
        TransmitByte(5) = (WarnToSimulator.WarnIn >> 24) And &HFF
        CheckSum = CheckSum + TransmitByte(5)

        TransmitByte(6) = CheckSum And &HFF
        TransmitByte(7) = (CheckSum >> 8) And &HFF

        If VrSerialPort1.IsOpen Then
            Try
                VrSerialPort1.Write(TransmitByte, 0, 8)
            Catch ex As Exception
                MsgBox(ex.Message)
            End Try
        Else
            MsgBox("Please open virtual Serial Port firstly")
        End If
    End Sub
    Private Sub txtAnx_Leave(sender As Object, e As EventArgs) Handles txtAn1.Leave, txtAn2.Leave, txtAn3.Leave, txtAn4.Leave, txtAn5.Leave, txtAn6.Leave, txtAn7.Leave, txtAn8.Leave,
                                                                       txtAn9.Leave, txtAn10.Leave, txtAn11.Leave, txtAn12.Leave, txtAn13.Leave, txtAn14.Leave, txtAn15.Leave, txtAn16.Leave,
                                                                       txtAn17.Leave, txtAn18.Leave, txtAn19.Leave, txtAn20.Leave, txtAn21.Leave, txtAn22.Leave, txtAn23.Leave, txtAn24.Leave,
                                                                       txtAn25.Leave, txtAn26.Leave, txtAn27.Leave, txtAn28.Leave, txtAn29.Leave, txtAn30.Leave, txtAn31.Leave, txtAn32.Leave

        Dim AnalogV As Single
        AnalogV = CSng(sender.Text)
        If sender Is txtAn1 Then
            TransmitSimulaterAnalogValue(cmbWhichDevice.SelectedIndex, 0, AnalogV)
        ElseIf sender Is txtAn2 Then
            TransmitSimulaterAnalogValue(cmbWhichDevice.SelectedIndex, 1, AnalogV)
        ElseIf sender Is txtAn3 Then
            TransmitSimulaterAnalogValue(cmbWhichDevice.SelectedIndex, 2, AnalogV)
        ElseIf sender Is txtAn4 Then
            TransmitSimulaterAnalogValue(cmbWhichDevice.SelectedIndex, 3, AnalogV)
        ElseIf sender Is txtAn4 Then
            TransmitSimulaterAnalogValue(cmbWhichDevice.SelectedIndex, 3, AnalogV)
        ElseIf sender Is txtAn5 Then
            TransmitSimulaterAnalogValue(cmbWhichDevice.SelectedIndex, 4, AnalogV)
        ElseIf sender Is txtAn6 Then
            TransmitSimulaterAnalogValue(cmbWhichDevice.SelectedIndex, 5, AnalogV)
        ElseIf sender Is txtAn7 Then
            TransmitSimulaterAnalogValue(cmbWhichDevice.SelectedIndex, 6, AnalogV)
        ElseIf sender Is txtAn8 Then
            TransmitSimulaterAnalogValue(cmbWhichDevice.SelectedIndex, 7, AnalogV)
        ElseIf sender Is txtAn9 Then
            TransmitSimulaterAnalogValue(cmbWhichDevice.SelectedIndex, 8, AnalogV)
        ElseIf sender Is txtAn10 Then
            TransmitSimulaterAnalogValue(cmbWhichDevice.SelectedIndex, 9, AnalogV)
        ElseIf sender Is txtAn11 Then
            TransmitSimulaterAnalogValue(cmbWhichDevice.SelectedIndex, 10, AnalogV)
        ElseIf sender Is txtAn12 Then
            TransmitSimulaterAnalogValue(cmbWhichDevice.SelectedIndex, 11, AnalogV)
        ElseIf sender Is txtAn13 Then
            TransmitSimulaterAnalogValue(cmbWhichDevice.SelectedIndex, 12, AnalogV)
        ElseIf sender Is txtAn14 Then
            TransmitSimulaterAnalogValue(cmbWhichDevice.SelectedIndex, 13, AnalogV)
        ElseIf sender Is txtAn15 Then
            TransmitSimulaterAnalogValue(cmbWhichDevice.SelectedIndex, 14, AnalogV)
        ElseIf sender Is txtAn16 Then
            TransmitSimulaterAnalogValue(cmbWhichDevice.SelectedIndex, 15, AnalogV)
        ElseIf sender Is txtAn17 Then
            TransmitSimulaterAnalogValue(cmbWhichDevice.SelectedIndex, 16, AnalogV)
        ElseIf sender Is txtAn18 Then
            TransmitSimulaterAnalogValue(cmbWhichDevice.SelectedIndex, 17, AnalogV)
        ElseIf sender Is txtAn19 Then
            TransmitSimulaterAnalogValue(cmbWhichDevice.SelectedIndex, 18, AnalogV)
        ElseIf sender Is txtAn20 Then
            TransmitSimulaterAnalogValue(cmbWhichDevice.SelectedIndex, 19, AnalogV)
        ElseIf sender Is txtAn21 Then
            TransmitSimulaterAnalogValue(cmbWhichDevice.SelectedIndex, 20, AnalogV)
        ElseIf sender Is txtAn22 Then
            TransmitSimulaterAnalogValue(cmbWhichDevice.SelectedIndex, 21, AnalogV)
        ElseIf sender Is txtAn23 Then
            TransmitSimulaterAnalogValue(cmbWhichDevice.SelectedIndex, 22, AnalogV)
        ElseIf sender Is txtAn24 Then
            TransmitSimulaterAnalogValue(cmbWhichDevice.SelectedIndex, 23, AnalogV)
        ElseIf sender Is txtAn25 Then
            TransmitSimulaterAnalogValue(cmbWhichDevice.SelectedIndex, 24, AnalogV)
        ElseIf sender Is txtAn26 Then
            TransmitSimulaterAnalogValue(cmbWhichDevice.SelectedIndex, 25, AnalogV)
        ElseIf sender Is txtAn27 Then
            TransmitSimulaterAnalogValue(cmbWhichDevice.SelectedIndex, 26, AnalogV)
        ElseIf sender Is txtAn28 Then
            TransmitSimulaterAnalogValue(cmbWhichDevice.SelectedIndex, 27, AnalogV)
        ElseIf sender Is txtAn29 Then
            TransmitSimulaterAnalogValue(cmbWhichDevice.SelectedIndex, 28, AnalogV)
        ElseIf sender Is txtAn30 Then
            TransmitSimulaterAnalogValue(cmbWhichDevice.SelectedIndex, 29, AnalogV)
        ElseIf sender Is txtAn31 Then
            TransmitSimulaterAnalogValue(cmbWhichDevice.SelectedIndex, 30, AnalogV)
        ElseIf sender Is txtAn32 Then
            TransmitSimulaterAnalogValue(cmbWhichDevice.SelectedIndex, 31, AnalogV)
        End If
    End Sub


    Private Sub chkDinx_CheckedChanged(sender As Object, e As EventArgs) Handles chkDin1.CheckedChanged, chkDin2.CheckedChanged, chkDin3.CheckedChanged, chkDin4.CheckedChanged, chkDin5.CheckedChanged,
                                                                                 chkDin6.CheckedChanged, chkDin7.CheckedChanged, chkDin8.CheckedChanged, chkDin9.CheckedChanged, chkDin10.CheckedChanged
        TransmitSimulaterDinValue(cmbWhichDevice.SelectedIndex)
    End Sub

    Private Sub chkFLTx_CheckedChanged(sender As Object, e As EventArgs) Handles chkFLT1.CheckedChanged, chkFLT2.CheckedChanged, chkFLT3.CheckedChanged, chkFLT4.CheckedChanged, chkFLT5.CheckedChanged, chkFLT6.CheckedChanged, chkFLT7.CheckedChanged, chkFLT8.CheckedChanged,
                                                                                 chkFLT9.CheckedChanged, chkFLT10.CheckedChanged, chkFLT11.CheckedChanged, chkFLT12.CheckedChanged, chkFLT13.CheckedChanged, chkFLT14.CheckedChanged, chkFLT15.CheckedChanged, chkFLT16.CheckedChanged,
                                                                                 chkFLT17.CheckedChanged, chkFLT18.CheckedChanged, chkFLT19.CheckedChanged, chkFLT20.CheckedChanged, chkFLT21.CheckedChanged, chkFLT22.CheckedChanged, chkFLT23.CheckedChanged, chkFLT24.CheckedChanged,
                                                                                 chkFLT25.CheckedChanged, chkFLT26.CheckedChanged, chkFLT27.CheckedChanged, chkFLT28.CheckedChanged, chkFLT29.CheckedChanged, chkFLT30.CheckedChanged, chkFLT31.CheckedChanged, chkFLT32.CheckedChanged
        TransmitSimulaterFaultValue(cmbWhichDevice.SelectedIndex)
    End Sub

    Private Sub chkWrnx_CheckedChanged(sender As Object, e As EventArgs) Handles chkWrn1.CheckedChanged, chkWrn2.CheckedChanged, chkWrn3.CheckedChanged, chkWrn4.CheckedChanged, chkWrn5.CheckedChanged, chkWrn6.CheckedChanged, chkWrn7.CheckedChanged, chkWrn8.CheckedChanged,
                                                                                 chkWrn9.CheckedChanged, chkWrn10.CheckedChanged, chkWrn11.CheckedChanged, chkWrn12.CheckedChanged, chkWrn13.CheckedChanged, chkWrn14.CheckedChanged, chkWrn15.CheckedChanged, chkWrn16.CheckedChanged,
                                                                                 chkWrn17.CheckedChanged, chkWrn18.CheckedChanged, chkWrn19.CheckedChanged, chkWrn20.CheckedChanged, chkWrn21.CheckedChanged, chkWrn22.CheckedChanged, chkWrn23.CheckedChanged, chkWrn24.CheckedChanged,
                                                                                 chkWrn25.CheckedChanged, chkWrn26.CheckedChanged, chkWrn27.CheckedChanged, chkWrn28.CheckedChanged, chkWrn29.CheckedChanged, chkWrn30.CheckedChanged, chkWrn31.CheckedChanged, chkWrn32.CheckedChanged
        TransmitSimulaterWarningValue(cmbWhichDevice.SelectedIndex)
    End Sub

    Private Sub VrSerialPort1_DataReceived(sender As Object, e As IO.Ports.SerialDataReceivedEventArgs) Handles VrSerialPort1.DataReceived
        Dim DataFrmSimulatorTemp As InDataInforStru
        Dim DebugFrmSimulatorTemp As InDebugInforStru

        Static Position As Integer = 0
        Static FirstByte As Byte
        DebugFrmSimulatorTemp.Debug = New UShort(31) {}
        DebugFrmSimulatorTemp.DebugSng = New Single(31) {}
        Static ChecksumTEmp As Integer = 0
        Static ChecksumTEmp2 As Integer = 0
        Static byte4single(3) As Byte
        While VrSerialPort1.BytesToRead()
            If Position = 0 Then
                FirstByte = VrSerialPort1.ReadByte()
                Position = Position + 1
            Else
                Select Case FirstByte
                    Case 0 To 3
                        ''fault, warning data
                        If Position = 1 Then
                            DataFrmSimulatorTemp.DeviceNo = FirstByte
                            ChecksumTEmp2 = FirstByte
                            DataFrmSimulatorTemp.FaultIn = VrSerialPort1.ReadByte()
                            ChecksumTEmp2 = ChecksumTEmp2 + DataFrmSimulatorTemp.FaultIn
                        ElseIf Position = 2 Then
                            byte4single(0) = VrSerialPort1.ReadByte()
                            DataFrmSimulatorTemp.FaultIn = DataFrmSimulatorTemp.FaultIn + (CUInt(byte4single(0)) << 8)
                            ChecksumTEmp2 = ChecksumTEmp2 + byte4single(0)
                        ElseIf Position = 3 Then
                            byte4single(0) = VrSerialPort1.ReadByte()
                            DataFrmSimulatorTemp.FaultIn = DataFrmSimulatorTemp.FaultIn + (CUInt(byte4single(0)) << 16)
                            ChecksumTEmp2 = ChecksumTEmp2 + byte4single(0)
                        ElseIf Position = 4 Then
                            byte4single(0) = VrSerialPort1.ReadByte()
                            DataFrmSimulatorTemp.FaultIn = DataFrmSimulatorTemp.FaultIn + (CUInt(byte4single(0)) << 24)
                            ChecksumTEmp2 = ChecksumTEmp2 + byte4single(0)
                        ElseIf Position = 5 Then
                            byte4single(0) = VrSerialPort1.ReadByte()
                            DataFrmSimulatorTemp.WarnIn = byte4single(0)
                            ChecksumTEmp2 = ChecksumTEmp2 + byte4single(0)
                        ElseIf Position = 6 Then
                            byte4single(0) = VrSerialPort1.ReadByte()
                            DataFrmSimulatorTemp.WarnIn = DataFrmSimulatorTemp.WarnIn + (CUInt(byte4single(0)) << 8)
                            ChecksumTEmp2 = ChecksumTEmp2 + byte4single(0)
                        ElseIf Position = 7 Then
                            byte4single(0) = VrSerialPort1.ReadByte()
                            DataFrmSimulatorTemp.WarnIn = DataFrmSimulatorTemp.WarnIn + (CUInt(byte4single(0)) << 16)
                            ChecksumTEmp2 = ChecksumTEmp2 + byte4single(0)
                        ElseIf Position = 8 Then
                            byte4single(0) = VrSerialPort1.ReadByte()
                            DataFrmSimulatorTemp.WarnIn = DataFrmSimulatorTemp.WarnIn + (CUInt(byte4single(0)) << 24)
                            ChecksumTEmp2 = ChecksumTEmp2 + byte4single(0)
                        ElseIf Position = 9 Then
                            ChecksumTEmp = VrSerialPort1.ReadByte()
                        ElseIf Position = 10 Then
                            ChecksumTEmp = ChecksumTEmp + (VrSerialPort1.ReadByte() << 8)
                            If (ChecksumTEmp2 And &HFFFF) = (ChecksumTEmp And &HFFFF) Then
                                'correct data input
                                SyncLock SyncLockReceved
                                    DataFrmSimulator.DeviceNo = DataFrmSimulatorTemp.DeviceNo
                                    DataFrmSimulator.FaultIn = DataFrmSimulatorTemp.FaultIn
                                    DataFrmSimulator.WarnIn = DataFrmSimulatorTemp.WarnIn
                                End SyncLock
                            End If
                            Position = 0
                            Exit Select
                        Else
                            Position = 0
                            Exit Select
                        End If
                        Position = Position + 1
                    Case &HFF
                        'debug data
                        If Position = 1 Then
                            DebugFrmSimulatorTemp.DeviceNo = FirstByte
                            ChecksumTEmp2 = FirstByte
                        End If

                        If Position <= 64 Then
                            byte4single(0) = VrSerialPort1.ReadByte()
                            If (Position Mod 2) = 1 Then
                                ''odd
                                DebugFrmSimulatorTemp.Debug((Position - 1) \ 2) = byte4single(0)
                            Else
                                ''even
                                DebugFrmSimulatorTemp.Debug((Position - 1) \ 2) = DebugFrmSimulatorTemp.Debug((Position - 1) \ 2) + (CUShort(byte4single(0)) << 8)
                            End If
                            ChecksumTEmp2 = ChecksumTEmp2 + byte4single(0)
                        ElseIf Position <= 192 Then  '64+4*32
                            If (Position Mod 4) = 1 Then
                                '65,69, 73,...
                                byte4single(0) = VrSerialPort1.ReadByte()
                                ChecksumTEmp2 = ChecksumTEmp2 + byte4single(0)
                            ElseIf (Position Mod 4) = 2 Then
                                '66,70,74,...
                                byte4single(1) = VrSerialPort1.ReadByte()
                                ChecksumTEmp2 = ChecksumTEmp2 + byte4single(1)
                            ElseIf (Position Mod 4) = 3 Then
                                '67,71,75,...
                                byte4single(2) = VrSerialPort1.ReadByte()
                                ChecksumTEmp2 = ChecksumTEmp2 + byte4single(2)
                            ElseIf (Position Mod 4) = 0 Then
                                '68,72,76,...
                                byte4single(3) = VrSerialPort1.ReadByte()
                                ChecksumTEmp2 = ChecksumTEmp2 + byte4single(3)
                                DebugFrmSimulatorTemp.DebugSng((Position - 65) \ 4) = BitConverter.ToSingle(byte4single, 0)
                            End If

                        ElseIf Position = 193 Then
                            ChecksumTEmp = VrSerialPort1.ReadByte()
                        ElseIf Position = 194 Then
                            ChecksumTEmp = ChecksumTEmp + (VrSerialPort1.ReadByte() << 8)
                            If (ChecksumTEmp2 And &HFFFF) = (ChecksumTEmp And &HFFFF) Then
                                'correct debug data
                                For i As Integer = 0 To 31
                                    SyncLock SyncLockReceved
                                        DebugFrmSimulator.Debug(i) = DebugFrmSimulatorTemp.Debug(i)
                                    End SyncLock
                                    SyncLock SyncLockReceved
                                        DebugFrmSimulator.DebugSng(i) = DebugFrmSimulatorTemp.DebugSng(i)
                                    End SyncLock
                                Next
                            End If
                            Position = 0
                            Exit Select
                        Else
                            Position = 0
                            Exit Select
                        End If
                        Position = Position + 1
                    Case Else
                        Position = 0
                        Exit Select
                End Select
            End If
        End While
        

    End Sub

    Private Sub tim4ReceivedData_Tick(sender As Object, e As EventArgs) Handles tim4ReceivedData.Tick
        Dim dataUpdated As Boolean = False
        SyncLock SyncLockReceved
            If DataFrmSimulator.DeviceNo <> DataFrmSimulator_old.DeviceNo Then
                dataUpdated = True
                DataFrmSimulator_old.DeviceNo = DataFrmSimulator.DeviceNo
                DataFrmSimulator_old.FaultIn = DataFrmSimulator.FaultIn
                DataFrmSimulator_old.WarnIn = DataFrmSimulator.WarnIn
            Else
                If DataFrmSimulator.FaultIn <> DataFrmSimulator_old.FaultIn Then
                    dataUpdated = True
                    DataFrmSimulator_old.FaultIn = DataFrmSimulator.FaultIn
                    DataFrmSimulator_old.WarnIn = DataFrmSimulator.WarnIn
                ElseIf DataFrmSimulator.WarnIn <> DataFrmSimulator_old.WarnIn Then
                    dataUpdated = True
                    DataFrmSimulator_old.FaultIn = DataFrmSimulator.FaultIn
                    DataFrmSimulator_old.WarnIn = DataFrmSimulator.WarnIn
                End If
            End If
        End SyncLock

        If dataUpdated Then
            dataUpdated = False
            'Modify Fault and Waring Checkbox
            chkFLT1.Checked = IIf((DataFrmSimulator_old.FaultIn And &H1) <> 0, True, False)
            chkFLT2.Checked = IIf((DataFrmSimulator_old.FaultIn And (&H1 << 1)) <> 0, True, False)
            chkFLT3.Checked = IIf((DataFrmSimulator_old.FaultIn And (&H1 << 2)) <> 0, True, False)
            chkFLT4.Checked = IIf((DataFrmSimulator_old.FaultIn And (&H1 << 3)) <> 0, True, False)
            chkFLT5.Checked = IIf((DataFrmSimulator_old.FaultIn And (&H1 << 4)) <> 0, True, False)
            chkFLT6.Checked = IIf((DataFrmSimulator_old.FaultIn And (&H1 << 5)) <> 0, True, False)
            chkFLT7.Checked = IIf((DataFrmSimulator_old.FaultIn And (&H1 << 6)) <> 0, True, False)
            chkFLT8.Checked = IIf((DataFrmSimulator_old.FaultIn And (&H1 << 7)) <> 0, True, False)
            chkFLT9.Checked = IIf((DataFrmSimulator_old.FaultIn And (&H1 << 8)) <> 0, True, False)
            chkFLT10.Checked = IIf((DataFrmSimulator_old.FaultIn And (&H1 << 9)) <> 0, True, False)
            chkFLT11.Checked = IIf((DataFrmSimulator_old.FaultIn And (&H1 << 10)) <> 0, True, False)
            chkFLT12.Checked = IIf((DataFrmSimulator_old.FaultIn And (&H1 << 11)) <> 0, True, False)
            chkFLT13.Checked = IIf((DataFrmSimulator_old.FaultIn And (&H1 << 12)) <> 0, True, False)
            chkFLT14.Checked = IIf((DataFrmSimulator_old.FaultIn And (&H1 << 13)) <> 0, True, False)
            chkFLT15.Checked = IIf((DataFrmSimulator_old.FaultIn And (&H1 << 14)) <> 0, True, False)
            chkFLT16.Checked = IIf((DataFrmSimulator_old.FaultIn And (&H1 << 15)) <> 0, True, False)
            chkFLT17.Checked = IIf((DataFrmSimulator_old.FaultIn And (&H1 << 16)) <> 0, True, False)
            chkFLT18.Checked = IIf((DataFrmSimulator_old.FaultIn And (&H1 << 17)) <> 0, True, False)
            chkFLT19.Checked = IIf((DataFrmSimulator_old.FaultIn And (&H1 << 18)) <> 0, True, False)
            chkFLT20.Checked = IIf((DataFrmSimulator_old.FaultIn And (&H1 << 19)) <> 0, True, False)
            chkFLT21.Checked = IIf((DataFrmSimulator_old.FaultIn And (&H1 << 20)) <> 0, True, False)
            chkFLT22.Checked = IIf((DataFrmSimulator_old.FaultIn And (&H1 << 21)) <> 0, True, False)
            chkFLT23.Checked = IIf((DataFrmSimulator_old.FaultIn And (&H1 << 22)) <> 0, True, False)
            chkFLT24.Checked = IIf((DataFrmSimulator_old.FaultIn And (&H1 << 23)) <> 0, True, False)
            chkFLT25.Checked = IIf((DataFrmSimulator_old.FaultIn And (&H1 << 24)) <> 0, True, False)
            chkFLT26.Checked = IIf((DataFrmSimulator_old.FaultIn And (&H1 << 25)) <> 0, True, False)
            chkFLT27.Checked = IIf((DataFrmSimulator_old.FaultIn And (&H1 << 26)) <> 0, True, False)
            chkFLT28.Checked = IIf((DataFrmSimulator_old.FaultIn And (&H1 << 27)) <> 0, True, False)
            chkFLT29.Checked = IIf((DataFrmSimulator_old.FaultIn And (&H1 << 28)) <> 0, True, False)
            chkFLT30.Checked = IIf((DataFrmSimulator_old.FaultIn And (&H1 << 29)) <> 0, True, False)
            chkFLT31.Checked = IIf((DataFrmSimulator_old.FaultIn And (&H1 << 30)) <> 0, True, False)
            chkFLT32.Checked = IIf((DataFrmSimulator_old.FaultIn And (&H1UI << 31)) <> 0, True, False)

            chkWrn1.Checked = IIf((DataFrmSimulator_old.WarnIn And &H1) <> 0, True, False)
            chkWrn2.Checked = IIf((DataFrmSimulator_old.WarnIn And (&H1 << 1)) <> 0, True, False)
            chkWrn3.Checked = IIf((DataFrmSimulator_old.WarnIn And (&H1 << 2)) <> 0, True, False)
            chkWrn4.Checked = IIf((DataFrmSimulator_old.WarnIn And (&H1 << 3)) <> 0, True, False)
            chkWrn5.Checked = IIf((DataFrmSimulator_old.WarnIn And (&H1 << 4)) <> 0, True, False)
            chkWrn6.Checked = IIf((DataFrmSimulator_old.WarnIn And (&H1 << 5)) <> 0, True, False)
            chkWrn7.Checked = IIf((DataFrmSimulator_old.WarnIn And (&H1 << 6)) <> 0, True, False)
            chkWrn8.Checked = IIf((DataFrmSimulator_old.WarnIn And (&H1 << 7)) <> 0, True, False)
            chkWrn9.Checked = IIf((DataFrmSimulator_old.WarnIn And (&H1 << 8)) <> 0, True, False)
            chkWrn10.Checked = IIf((DataFrmSimulator_old.WarnIn And (&H1 << 9)) <> 0, True, False)
            chkWrn11.Checked = IIf((DataFrmSimulator_old.WarnIn And (&H1 << 10)) <> 0, True, False)
            chkWrn12.Checked = IIf((DataFrmSimulator_old.WarnIn And (&H1 << 11)) <> 0, True, False)
            chkWrn13.Checked = IIf((DataFrmSimulator_old.WarnIn And (&H1 << 12)) <> 0, True, False)
            chkWrn14.Checked = IIf((DataFrmSimulator_old.WarnIn And (&H1 << 13)) <> 0, True, False)
            chkWrn15.Checked = IIf((DataFrmSimulator_old.WarnIn And (&H1 << 14)) <> 0, True, False)
            chkWrn16.Checked = IIf((DataFrmSimulator_old.WarnIn And (&H1 << 15)) <> 0, True, False)
            chkWrn17.Checked = IIf((DataFrmSimulator_old.WarnIn And (&H1 << 16)) <> 0, True, False)
            chkWrn18.Checked = IIf((DataFrmSimulator_old.WarnIn And (&H1 << 17)) <> 0, True, False)
            chkWrn19.Checked = IIf((DataFrmSimulator_old.WarnIn And (&H1 << 18)) <> 0, True, False)
            chkWrn20.Checked = IIf((DataFrmSimulator_old.WarnIn And (&H1 << 19)) <> 0, True, False)
            chkWrn21.Checked = IIf((DataFrmSimulator_old.WarnIn And (&H1 << 20)) <> 0, True, False)
            chkWrn22.Checked = IIf((DataFrmSimulator_old.WarnIn And (&H1 << 21)) <> 0, True, False)
            chkWrn23.Checked = IIf((DataFrmSimulator_old.WarnIn And (&H1 << 22)) <> 0, True, False)
            chkWrn24.Checked = IIf((DataFrmSimulator_old.WarnIn And (&H1 << 23)) <> 0, True, False)
            chkWrn25.Checked = IIf((DataFrmSimulator_old.WarnIn And (&H1 << 24)) <> 0, True, False)
            chkWrn26.Checked = IIf((DataFrmSimulator_old.WarnIn And (&H1 << 25)) <> 0, True, False)
            chkWrn27.Checked = IIf((DataFrmSimulator_old.WarnIn And (&H1 << 26)) <> 0, True, False)
            chkWrn28.Checked = IIf((DataFrmSimulator_old.WarnIn And (&H1 << 27)) <> 0, True, False)
            chkWrn29.Checked = IIf((DataFrmSimulator_old.WarnIn And (&H1 << 28)) <> 0, True, False)
            chkWrn30.Checked = IIf((DataFrmSimulator_old.WarnIn And (&H1 << 29)) <> 0, True, False)
            chkWrn31.Checked = IIf((DataFrmSimulator_old.WarnIn And (&H1 << 30)) <> 0, True, False)
            chkWrn32.Checked = IIf((DataFrmSimulator_old.WarnIn And (&H1UI << 31)) <> 0, True, False)

        End If

        'Debug
        For i As Integer = 0 To 31
            SyncLock SyncLockReceved
                If DebugFrmSimulator.Debug(i) <> DebugFrmSimulator_old.Debug(i) Then
                    dataUpdated = True
                    DebugFrmSimulator_old.Debug(i) = DebugFrmSimulator.Debug(i)
                End If
            End SyncLock

            If dataUpdated Then
                dataUpdated = False
                Select Case i
                    Case 0
                        lblDbg0.Text = Convert.ToString(DebugFrmSimulator_old.Debug(i), 16)
                    Case 1
                        lblDbg1.Text = Convert.ToString(DebugFrmSimulator_old.Debug(i), 16)
                    Case 2
                        lblDbg2.Text = Convert.ToString(DebugFrmSimulator_old.Debug(i), 16)
                    Case 3
                        lblDbg3.Text = Convert.ToString(DebugFrmSimulator_old.Debug(i), 16)
                    Case 4
                        lblDbg4.Text = Convert.ToString(DebugFrmSimulator_old.Debug(i), 16)
                    Case 5
                        lblDbg5.Text = Convert.ToString(DebugFrmSimulator_old.Debug(i), 16)
                    Case 6
                        lblDbg6.Text = Convert.ToString(DebugFrmSimulator_old.Debug(i), 16)
                    Case 7
                        lblDbg7.Text = Convert.ToString(DebugFrmSimulator_old.Debug(i), 16)
                    Case 8
                        lblDbg8.Text = Convert.ToString(DebugFrmSimulator_old.Debug(i), 16)
                    Case 9
                        lblDbg9.Text = Convert.ToString(DebugFrmSimulator_old.Debug(i), 16)
                    Case 10
                        lblDbg10.Text = Convert.ToString(DebugFrmSimulator_old.Debug(i), 16)
                    Case 11
                        lblDbg11.Text = Convert.ToString(DebugFrmSimulator_old.Debug(i), 16)
                    Case 12
                        lblDbg12.Text = Convert.ToString(DebugFrmSimulator_old.Debug(i), 16)
                    Case 13
                        lblDbg13.Text = Convert.ToString(DebugFrmSimulator_old.Debug(i), 16)
                    Case 14
                        lblDbg14.Text = Convert.ToString(DebugFrmSimulator_old.Debug(i), 16)
                    Case 15
                        lblDbg15.Text = Convert.ToString(DebugFrmSimulator_old.Debug(i), 16)

                    Case 16
                        lblDbg16.Text = Convert.ToString(DebugFrmSimulator_old.Debug(i), 16)
                    Case 17
                        lblDbg17.Text = Convert.ToString(DebugFrmSimulator_old.Debug(i), 16)
                    Case 18
                        lblDbg18.Text = Convert.ToString(DebugFrmSimulator_old.Debug(i), 16)
                    Case 19
                        lblDbg19.Text = Convert.ToString(DebugFrmSimulator_old.Debug(i), 16)
                    Case 20
                        lblDbg20.Text = Convert.ToString(DebugFrmSimulator_old.Debug(i), 16)
                    Case 21
                        lblDbg21.Text = Convert.ToString(DebugFrmSimulator_old.Debug(i), 16)
                    Case 22
                        lblDbg22.Text = Convert.ToString(DebugFrmSimulator_old.Debug(i), 16)
                    Case 23
                        lblDbg23.Text = Convert.ToString(DebugFrmSimulator_old.Debug(i), 16)
                    Case 24
                        lblDbg24.Text = Convert.ToString(DebugFrmSimulator_old.Debug(i), 16)
                    Case 25
                        lblDbg25.Text = Convert.ToString(DebugFrmSimulator_old.Debug(i), 16)
                    Case 26
                        lblDbg26.Text = Convert.ToString(DebugFrmSimulator_old.Debug(i), 16)
                    Case 27
                        lblDbg27.Text = Convert.ToString(DebugFrmSimulator_old.Debug(i), 16)
                    Case 28
                        lblDbg28.Text = Convert.ToString(DebugFrmSimulator_old.Debug(i), 16)
                    Case 29
                        lblDbg29.Text = Convert.ToString(DebugFrmSimulator_old.Debug(i), 16)
                    Case 30
                        lblDbg30.Text = Convert.ToString(DebugFrmSimulator_old.Debug(i), 16)
                    Case 31
                        lblDbg31.Text = Convert.ToString(DebugFrmSimulator_old.Debug(i), 16)
                End Select
               
            End If

            SyncLock SyncLockReceved
                If DebugFrmSimulator.DebugSng(i) <> DebugFrmSimulator_old.DebugSng(i) Then
                    dataUpdated = True
                    DebugFrmSimulator_old.DebugSng(i) = DebugFrmSimulator.DebugSng(i)
                End If
            End SyncLock
            If dataUpdated Then
                dataUpdated = False
                Select Case i
                    Case 0
                        lblDbgSng0.Text = DebugFrmSimulator_old.DebugSng(i).ToString("F2")
                    Case 1
                        lblDbgSng1.Text = DebugFrmSimulator_old.DebugSng(i).ToString("F2")
                    Case 2
                        lblDbgSng2.Text = DebugFrmSimulator_old.DebugSng(i).ToString("F2")
                    Case 3
                        lblDbgSng3.Text = DebugFrmSimulator_old.DebugSng(i).ToString("F2")
                    Case 4
                        lblDbgSng4.Text = DebugFrmSimulator_old.DebugSng(i).ToString("F2")
                    Case 5
                        lblDbgSng5.Text = DebugFrmSimulator_old.DebugSng(i).ToString("F2")
                    Case 6
                        lblDbgSng6.Text = DebugFrmSimulator_old.DebugSng(i).ToString("F2")
                    Case 7
                        lblDbgSng7.Text = DebugFrmSimulator_old.DebugSng(i).ToString("F2")
                    Case 8
                        lblDbgSng8.Text = DebugFrmSimulator_old.DebugSng(i).ToString("F2")
                    Case 9
                        lblDbgSng9.Text = DebugFrmSimulator_old.DebugSng(i).ToString("F2")
                    Case 10
                        lblDbgSng10.Text = DebugFrmSimulator_old.DebugSng(i).ToString("F2")
                    Case 11
                        lblDbgSng11.Text = DebugFrmSimulator_old.DebugSng(i).ToString("F2")
                    Case 12
                        lblDbgSng12.Text = DebugFrmSimulator_old.DebugSng(i).ToString("F2")
                    Case 13
                        lblDbgSng13.Text = DebugFrmSimulator_old.DebugSng(i).ToString("F2")
                    Case 14
                        lblDbgSng14.Text = DebugFrmSimulator_old.DebugSng(i).ToString("F2")
                    Case 15
                        lblDbgSng15.Text = DebugFrmSimulator_old.DebugSng(i).ToString("F2")
                    Case 16
                        lblDbgSng16.Text = DebugFrmSimulator_old.DebugSng(i).ToString("F2")
                    Case 17
                        lblDbgSng17.Text = DebugFrmSimulator_old.DebugSng(i).ToString("F2")
                    Case 18
                        lblDbgSng18.Text = DebugFrmSimulator_old.DebugSng(i).ToString("F2")
                    Case 19
                        lblDbgSng19.Text = DebugFrmSimulator_old.DebugSng(i).ToString("F2")
                    Case 20
                        lblDbgSng20.Text = DebugFrmSimulator_old.DebugSng(i).ToString("F2")
                    Case 21
                        lblDbgSng21.Text = DebugFrmSimulator_old.DebugSng(i).ToString("F2")
                    Case 22
                        lblDbgSng22.Text = DebugFrmSimulator_old.DebugSng(i).ToString("F2")
                    Case 23
                        lblDbgSng23.Text = DebugFrmSimulator_old.DebugSng(i).ToString("F2")
                    Case 24
                        lblDbgSng24.Text = DebugFrmSimulator_old.DebugSng(i).ToString("F2")
                    Case 25
                        lblDbgSng25.Text = DebugFrmSimulator_old.DebugSng(i).ToString("F2")
                    Case 26
                        lblDbgSng26.Text = DebugFrmSimulator_old.DebugSng(i).ToString("F2")
                    Case 27
                        lblDbgSng27.Text = DebugFrmSimulator_old.DebugSng(i).ToString("F2")
                    Case 28
                        lblDbgSng28.Text = DebugFrmSimulator_old.DebugSng(i).ToString("F2")
                    Case 29
                        lblDbgSng29.Text = DebugFrmSimulator_old.DebugSng(i).ToString("F2")
                    Case 30
                        lblDbgSng30.Text = DebugFrmSimulator_old.DebugSng(i).ToString("F2")
                    Case 31
                        lblDbgSng31.Text = DebugFrmSimulator_old.DebugSng(i).ToString("F2")
                End Select
            End If
        Next
        
    End Sub
End Class
